<?php

$appid = "YOURAPPID"; 
$secret = "YOURSECRET";
$wslogin_server = "https://api.login.yahoo.com";	
$wslogin_server_long = "https://api.login.yahoo.com/WSLogin/V1/wslogin";


//signs a the URL that sends the user to the Yahoo! login server
function yahoo_sign_url( $url, $secret ) {
	$parts = parse_url( $url );

	$ts = time();
	$relative_uri = "";

	if ( isset( $parts["path"] ) ){
		$relative_uri .= $parts["path"];
	}

	if ( isset ( $parts["query" ] ) ) {
		$relative_uri .= "?" . $parts["query"] . "&ts=$ts";
	} else {
		// no arguments passed
		$relative_uri .= "?ts=$ts";
	}
    
	$sig = md5( $relative_uri . $secret );
	$signed_url = $parts["scheme"] . "://" .  $parts["host"] . $relative_uri . "&sig=$sig";

	return $signed_url;
}

//once you have the token you can request a cookie to make calls on behalf of the user
function get_cookie( $url ) {
	$ch = curl_init();
	curl_setopt( $ch, CURLOPT_URL, $url );
	curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
	$xml = curl_exec( $ch );
	
	if (  preg_match( "/(Y=.*)/", $xml, $match_array ) == 1 ) {
		$cookie = $match_array[1];
	}
	if (  preg_match( "/<WSSID>(.+)<\/WSSID>/", $xml, $match_array ) == 1 ) {
		$WSSID = $match_array[1];
	}
	if (  preg_match( "/<Timeout>(.+)<\/Timeout>/", $xml, $match_array ) == 1 ) {
		$timeout = $match_array[1];
	}
	curl_close($ch);

	$rv = array();
	$rv["cookie"] = $cookie;
	$rv["WSSID"] = $WSSID;
	$rv["timeout"]   = $timeout;
       return $rv;
}

function yahoo_sig_validate( $secret ) {
	$ts  = $_GET["ts"];
	$sig = $_GET["sig"];
	$relative_url = getenv( 'REQUEST_URI' );
	$match = array();
	$preg_rv = preg_match(  "/^(.+)&sig=(\w{32})$/", $relative_url, $match);

	if ( $preg_rv == 1 ) {
	  if ($match[2] != $sig ) {
	    $rv = array( "status" => false,
			 "error"  =>"Invalid signature passed passed?" . $match[2] . ", $sig " );
	    return $rv;
	  }
	}
	else {
	  $rv = array( "status" => false,
		       "error"  =>"Invalid url passed? relative_url: $relative_url, preg_rv: $preg_rv" );
	return $rv;
	}

	// at this point, the url looks valid, and we pulled the sig from the url
	// The sig was guaranteed to be the last param on the url
	$relative_url_without_sig = $match[1];

	$current_time = time();
	$clock_skew  = abs($current_time - $ts);
	if ( $clock_skew >= 300 ) {
		$rv = array( "status" => false,
			     "error"  => "invalid timestamp: clock_skew is $clock_skew seconds, current time is $current_time, ts is $ts" );
		return $rv;
	}
	
	$sig_input = $relative_url_without_sig . $secret;
	$calculated_sig = md5($sig_input);
	if ( $calculated_sig == $sig ) {
		$rv = array( "status"=> true );
		return $rv; // success!!
	}
	else {
		$rv = array( "status" => false,
			     "error"  => "calculated_sig was $calculated_sig, supplied sig was $sig, sig input was $sig_input" );
		return $rv;
	}
}

?>
